<script setup>
import {reactive, ref} from 'vue'

const tasks = reactive([])

// Local Storage (como DB)
// localStorage.removeItem('tasks') // Para pruebas de cambios
if (localStorage.tasks) {
  tasks.push(...JSON.parse(localStorage.tasks))
} else {
  tasks.push({capacity: 30, occupation: 40, activated: false, floor: '1'})
  tasks.push({capacity: 10, occupation: 20, activated: false, floor: '1'})
  tasks.push({capacity: 5, occupation: 10, activated: false, floor: '2'})
}
const updateDB = () => {
  localStorage.tasks = JSON.stringify(tasks)
}

// Redactar Sala
const saveRoom = (index) => {
  tasks[index].activated = false
  updateDB()
}

// Añadir Sala
const addRoom = () => {
  if (sortFloor.value === '1') {
    tasks.push({capacity: 30, occupation: 40, floor: '1'})
  } else if (sortFloor.value === '2') {
    tasks.push({capacity: 30, occupation: 40, floor: '2'})
  }
  updateDB()
}

// Eliminar Sala
const removeRoom = (index) => {
  tasks.splice(index, 1)
  localStorage.removeItem('tasks[index]')
  updateDB()
}

// Filtrar Salas
const sortRoom = ref(0)
const sortRoomAction = () => {
  if (sortRoom.value === '1') {
    return tasks.sort((a, b) => a.capacity < b.capacity ? 1 : 0)
  } else if (sortRoom.value === '2') {
    return tasks.sort((a, b) => a.occupation < b.occupation ? 1 : 0)
  }
}

// Plantas a elegir
const sortFloor = ref(0)

</script>

<template>
  <main class="container my-5">
    <div class="border-bottom pb-4">
      <div class="fs-1">Salas</div>
      <label for="floors">
        <select v-model="sortFloor" id="floors">
          <option value="1">Planta 1</option>
          <option value="2">Planta 2</option>
        </select>
      </label>
    </div>
    <div class="mt-4 rounded-4 border border-dark p-4">
      <div class="d-flex align-items-center justify-content-between">
        <span class="fs-5 fw-bold">Planta {{ sortFloor }}</span>
        <div>
          <button @click="addRoom" class="btn primary-background-color text-white mx-3">Añadir sala</button>
          <select v-model="sortRoom" name="" id="" @change="sortRoomAction">
            <option value="0" disabled>Ordenar por:</option>
            <option value="1">Más capacidad</option>
            <option value="2">Más ocupación</option>
          </select>
        </div>
      </div>
      <div class="row">
        <div class="col-auto" v-for="(value, index) in tasks" :key="index">
          <div v-if="value.floor === sortFloor" class="col-12 bg-light rounded-4 p-4">
            <div class="d-flex justify-content-between align-items-center">
              <span class="fs-5 fw-bold">Sala planta 1</span>
              <input type="button" value="X" @click="removeRoom(index)" class="btn btn-danger">
            </div>
            <div class="my-3">
              <div class="">Capacidad máxima</div>
              <label class="w-100">
                <input v-if="!value.activated" type="text" :value="value.capacity"
                       class="w-100 bg-white py-2 px-3 border"
                       readonly>
                <textarea v-model="value.capacity" v-else></textarea>
              </label>
            </div>
            <div>
              <div class="">Ocupación</div>
              <label class="w-100 ">
                <input v-if="!value.activated" type="text" :value="value.occupation"
                       class="w-100 bg-white py-2 px-3 border"
                       readonly>
                <textarea v-model="value.occupation" v-else></textarea>
              </label>
            </div>
            <div class="d-flex justify-content-end mt-4 gap-2">
              <button v-if="!value.activated" @click="value.activated = !value.activated" class="btn">Modificar</button>
              <button v-else @click="saveRoom(index)">Save</button>
            </div>
          </div>
        </div>
      </div>
    </div>
  </main>
</template>

<style scoped>
</style>
